<?php
/*
Plugin Name: wp-einsatz
Plugin Script: wp-einsatz.php
Plugin URI: http://file.fw-gz.de/plugins/
Description: Einsatzliste und Widget fuer Feuerwehren
Version: 0.2
Author: Stefan Hauf
Author URI: http://www.feuerwehr-guenzburg.de
*/
function jal_install () {
  global $wpdb;
   
  $table_name = $wpdb->prefix . "einsaetze";
  if($wpdb->get_var("show tables like '$table_name'") != $table_name) {      
    $sql = "CREATE TABLE " . $table_name . " (
	    ID mediumint(9) NOT NULL AUTO_INCREMENT,
	    Datum datetime NOT NULL default '0000-00-00 00:00:00',
	    Ort varchar(100) NOT NULL default '',
	    Art varchar(100) NOT NULL default '',
	    UNIQUE KEY ID (ID)
	    );";

    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);
    $insert = "INSERT INTO $table_name (Datum, Ort, Art) VALUES (NOW(), 'Musterstadt', 'Fehlalarm')";
    $results = $wpdb->query( $insert );
  }
}
register_activation_hook(__FILE__,'jal_install');

function addHeaderCode() {
  echo '<link type="text/css" rel="stylesheet" href="' . get_bloginfo('wpurl') . '/wp-content/plugins/wp-einsatz/wp-einsatz.css" />' . "\n";		
}
add_action('wp_head', 'addHeaderCode', 1);
	  

function einsatz_filter($content) {
  global $wpdb;  
  $table_name = $wpdb->prefix . "einsaetze";
  $html  = "<table class='einsatzliste' border='1'>\n";
  $html .= "  <tr>\n";
  $ueberschriften = $wpdb->get_results("SHOW COLUMNS FROM $table_name");
  foreach ($ueberschriften as $ueberschrift) {
    $field = $ueberschrift->Field;
    if ($field == "ID") continue; // ignore ID
    $html .= "    <th>".$field."</th>\n";         
    if ($field == "Datum")
      $html .= "    <th>Uhrzeit</th>\n";
    else          
      $fields[] = $field;
  }
  $html .= "  </tr>\n";
  
  $jahr = $wpdb->escape(get_post_meta(get_the_ID(),'jahr',TRUE));
  if (strlen($jahr) == 4) {
  $einsaetze = $wpdb->get_results("SELECT *, UNIX_TIMESTAMP(Datum) AS timestamp FROM $table_name WHERE YEAR(Datum) = '$jahr' ORDER BY Datum ASC", ARRAY_A);
  }
  else {
  $einsaetze = $wpdb->get_results("SELECT *, UNIX_TIMESTAMP(Datum) AS timestamp FROM $table_name ORDER BY Datum ASC", ARRAY_A);
  }
  foreach ($einsaetze as $einsatz) {    
    $i++;
    $html .= ($i%2) ? "  <tr>\n" : "  <tr class='alt'>\n";
    $html .= "    <td>".strftime('%d. %b', $einsatz['timestamp'])."</td>\n";
    $html .= "    <td>".strftime('%H:%M', $einsatz['timestamp'])."</td>\n";
    foreach ($fields as $field) {
      $html .= "    <td>".$einsatz[$field]."</td>\n";
    }          
    $html .= "  </tr>\n";
  }	 
  $html .= "</table>\n";
  if (get_option('blog_charset') == "UTF-8") 
    $content = eregi_replace( '<!--einsatzliste-->', utf8_encode($html), $content );
  else
    $content = eregi_replace( '<!--einsatzliste-->', $html, $content );
  return $content;
}
add_filter('the_content', 'einsatz_filter');

function einsatz_widget_init() 
{
  function einsatz_widget_list() 
  {
    global $wpdb;
    $table_name = $wpdb->prefix . "einsaetze";

    $einsatz = $wpdb->get_row("SELECT *, DATE_FORMAT(Datum, '%d. %b %H:%i') AS Datum_F FROM $table_name ORDER BY Datum DESC LIMIT 1");

    echo "<li id=\"archives\" class=\"widget widget_archive\"><h2 class=\"widgettitle\">Letzter Einsatz</h2>";
    echo utf8_encode("<ul><li><a href='".get_settings('home')."/einsatz/'>".$einsatz->Datum_F."<br>".$einsatz->Ort."<br>".$einsatz->Art."</a></li></ul></li>\n");
  }

  register_sidebar_widget(
    array(__('Lezter Einsatz','einsatz'),'widgets'),
    'einsatz_widget_list'
  );
  register_widget_control(
    array(__('Letzter Einsatz','einsatz'),'widgets'),
    'einsatz_widget_list_control'
  );
}

add_action('widgets_init', 'einsatz_widget_init');
?>
